"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var reducer_util_1 = require("./reducer.util");
var ActionHandlersUtil;
(function (ActionHandlersUtil) {
    ActionHandlersUtil.reduceXActionHandlers = function (xActionHandlers, withSelector) {
        return Object.keys(xActionHandlers).reduce(function (result, key) {
            var value = xActionHandlers[key];
            if (typeof value === "function") {
                result[key] = value;
            }
            else {
                ActionHandlersUtil.mergeActionHandlers(result, withSelector(key), value);
            }
            return result;
        }, {});
    };
    ActionHandlersUtil.mergeActionHandlers = function (target, selector, source) {
        return Object.keys(source).reduce(function (result, key) {
            var value = source[key];
            if (typeof value === "function") {
                result[key] = reducer_util_1.ReducerUtil.mapReducer(selector, value);
            }
            else {
                ActionHandlersUtil.mergeActionHandlers(result, selector.select(key), value);
            }
            return result;
        }, target);
    };
})(ActionHandlersUtil = exports.ActionHandlersUtil || (exports.ActionHandlersUtil = {}));
//# sourceMappingURL=action.handlers.util.js.map