"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var selector_util_1 = require("./selector.util");
exports.createImmutableSelector = function () {
    var keys = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        keys[_i] = arguments[_i];
    }
    return (function (_keys) {
        return {
            keys: function () {
                var xKeys = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    xKeys[_i] = arguments[_i];
                }
                return (_keys.concat(xKeys));
            },
            select: function (key) { return exports.createImmutableSelector.apply(void 0, _keys.concat([key])); },
            get: function (state) { return state.getIn(_keys); },
            set: function (state, value) { return state.setIn(keys.slice(), value); },
            setIn: function (state, key, value) { return Array.isArray(key) ? state.setIn(_keys.concat(key), value) : state.setIn(_keys.concat([key]), value); },
            push: function (state, value) { return state.updateIn(_keys.slice(), function (list) { return list.push(value); }); },
            pushIn: function (state, key, value) { return Array.isArray(key) ? state.updateIn(_keys.concat(key), function (list) { return list.push(value); }) : state.updateIn(_keys.concat([key]), function (list) { return list.push(value); }); },
        };
    })(keys);
};
exports.withImmutableSelector = selector_util_1.SelectorUtil.createWithSelector(exports.createImmutableSelector);
//# sourceMappingURL=with.immutable.selector.js.map